using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.GroupingGridExcelConverter;
using System.Diagnostics;
using Syncfusion.GridExcelConverter;
using Syncfusion.XlsIO;

namespace I62024
{
    public partial class Form1 : Form
    {
        private DataTable dataTable1;
        public Form1()
        {
            InitializeComponent();

            #region DataSource
            dataTable1 = new DataTable();
            for (int col = 0; col < 300; col++)
                dataTable1.Columns.Add("Column" + (col + 1).ToString());

            for (int row = 0; row < 100; row++)
            {
                DataRow dRow = dataTable1.NewRow();
                for (int i = 0; i < dataTable1.Columns.Count; i++)
                    dRow[i] = "row" + (row + 1) + "col" + (i + 1);
                dataTable1.Rows.Add(dRow);
            }
            #endregion

            this.gridGroupingControl1.DataSource = dataTable1;
        }

        int colCount = 101;
        private void btnExport_Click(object sender, EventArgs e)
        {
            SelectedRangeExcelExportControl ExcelAdv = new SelectedRangeExcelExportControl();
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "Files(*.xls)|*.xls";
            saveFileDialog.DefaultExt = ".xls";

            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                ExcelAdv.SelectedExport(this.gridGroupingControl1.TableModel, saveFileDialog.FileName,colCount);

                if (MessageBox.Show("Do you wish to open the xls file now?", "Export to Excel", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    Process proc = new Process();
                    proc.StartInfo.FileName = saveFileDialog.FileName;
                    proc.Start();
                }
            }
        }
    }
}