#region Copyright Syncfusion Inc. 2001 - 2009
// Copyright Syncfusion Inc. 2001 - 2009. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Diagnostics;
using System.Text;

using Syncfusion.XlsIO;
using Syncfusion.XlsIO.Implementation;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Drawing;
using Syncfusion.GroupingGridExcelConverter;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.GridExcelConverter;
using Syncfusion.Grouping;

namespace I62024
{
	/// <summary>
	/// Summary description for SelectedRangeExcelExport.
	/// </summary>
	public class SelectedRangeExcelExportControl: GroupingGridExcelConverterControl
	{
		private int iStartColIndex = -1;
		private int iEndColIndex = -1;
        private int iStartRowIndex = -1;
        private int iEndRowIndex = -1;

		public SelectedRangeExcelExportControl():base()
		{
		}
		public void SelectedExport(GridTableModel model,string FileName,int count )
		{
			ExcelEngine engine = CreateEngine();
			IWorkbook book = engine.Excel.Workbooks.Create( 1 );
			IWorksheet sheet = book.Worksheets[ 0 ];
            GridRangeInfo range = GridRangeInfo.Cells(1, 1, model.RowCount, model.GroupingControl.TableDescriptor.GroupedColumns.Count + count);	
			ExportCells(range,model,sheet,count);
			book.SaveAs(FileName);  
			book.Close();
            engine.Dispose();
		}
		
		public void ExportCells(GridRangeInfo range, GridTableModel model, IWorksheet sheet,int count)
		{
			if( iStartColIndex < range.Left)
				iStartColIndex = range.Left;
			if( iEndColIndex < count + model.GroupingControl.TableDescriptor.GroupedColumns.Count)
				iEndColIndex = count + model.GroupingControl.TableDescriptor.GroupedColumns.Count;
            if (iStartRowIndex < range.Top)
                iStartRowIndex = range.Top;
            if (iEndRowIndex < range.Bottom)
                iEndRowIndex = range.Bottom;

            for (int i = range.Top, iRowRange = sheet.UsedRange.LastRow + 1; i <= range.Bottom; i++, iRowRange++)
            {
                for (int j = range.Left, iColRange = 1; j <= count; j++, iColRange++)
                {
                    this.CopyStyle(model[i, j], sheet[iRowRange, iColRange]);
                    sheet[iRowRange, iColRange].Text = model[i, j].FormattedText;
                }
            }
		}
	}
}
